using System;
using System.Collections.Generic;
using System.IO;
using Avalonia.Controls;
using Avalonia.Data;
using Avalonia.Interactivity;
using Avalonia.Media;

namespace Cryptura;

public partial class MainWindow : Window
{
    public static bool censorPasswords = true;
    private void AdjustThemeToPlatform()
    {
        if (Core.IsRunningOnGnome())
        {
            this.TransparencyLevelHint = new[] { WindowTransparencyLevel.None };
            this.Background = new SolidColorBrush(Color.Parse("#201c29"));
            AcrylicBorderObject.IsVisible = false;
        }
        else
        {
            this.TransparencyLevelHint = new[] { WindowTransparencyLevel.AcrylicBlur };
            this.Background = Brushes.Transparent;
            AcrylicBorderObject.IsVisible = true;
        }
    }
    public MainWindow()
    {
        InitializeComponent();
        AdjustThemeToPlatform();
        FetchPasswords();
        Password pw = new Password("monkeyman", "Himself");
    }
    
    private void FetchPasswords(){
        List<Password> passwords = new List<Password>();
        string[] WXFiles = Directory.GetFiles(Globals.GetKeyDirectory());
        foreach (string file in WXFiles)
        {
            if (Path.GetExtension(file).ToLower() == ".kf")
            {
                Password pw = new Password(file);
                pw.WxFile.Verify();
            }
            else
            {
                Console.WriteLine("Skipped non-key file: " + file);
            }

        }
        PasswordList.ItemsSource = passwords;
    }

    private void Control_OnLoaded(object? sender, RoutedEventArgs e)
    {
        if (sender is TextBox textBox)
        {
            Console.WriteLine("called");
            textBox.Bind(TextBlock.TextProperty, new Binding("Value"));
        }
    }

    private void Button_OnClick(object? sender, RoutedEventArgs e)
    {
        censorPasswords = !censorPasswords;
        FetchPasswords();
    }

    private void PasswordList_OnSelectionChanged(object? sender, SelectionChangedEventArgs e)
    {
        if (PasswordList.SelectedItem is Password password) Core.SetClipboardText(password.Value, this);
    }
}